#include <u.h>
#include <libc.h>
#include "httpd.h"
#include "misc.h"
//#include "libhttpd/misc.h"

//int obstime = 30;
extern int obstime;

#ifdef XXX
char *
skipto(char *s, char *p)
{
	while(*s && !strchr(p, *s))
		s++;
	return s;
}
#endif

int
okchk(char *ip)
{
	char *p, *p0, *q;
	long t0 = time(nil);
	p0 = getenv("okip");
	/*	if /env/okip is absent then p0==nil	*/
	/*	format of p0
	*	"ip1,tm1 ip2,tm2 ..."
	*	where tm is time	*/
	if(p0 == nil)
		return 0;
	while(p0){
		p = skipto(p0,",");
		if(*p != ',')
			break;
		*p++ = 0;
		q = skipto(p," ");
		*q++ = 0;
		if(strcmp(ip,p0) == 0 && t0 - atoi(p) < obstime)
			return 1;
		if(*q == 0)
			break;
		p0 = q;
	}
	return 0;
}

void
updateOkip(char *ip)
{
	char *p0;
	char *s,*s0,*e,*p,*q;
	long t0 = time(nil);
	int f = 0; /* flag */
	/*
	* 	you may be prompted here to add some lock protection in changing okip.
	*	however we should consider whether it will be really worthwhile.
	*	if okip is broken, the ip or someone's ip will not be authorized to
	*	escape maxconnect check, and this is all the effect.
	*	next access will fix the okip.
	*/
	p0 = getenv("okip");
	if(!p0)
		p0 = "";
	s0 = s = malloc(strlen(p0) + 32); /* enough for IPv4 */
	e = s + strlen(p0) + 32;
	while(p0){
		p = skipto(p0,",");
		if(*p != ',')
			break;
		*p++ = 0;
		q = skipto(p," ");
		*q++ = 0;
		if(strcmp(ip,p0) == 0){
			s = seprint(s,e,"%s,%d ", p0, t0);
			f = 1;
		}
		else if(t0 - atoi(p) < obstime)
			s = seprint(s,e,"%s,%s ", p0, p);
		if(*q == 0)
			break;
		p0 = q;
	}
	if(!f)
		s = seprint(s,e,"%s,%d ", ip, t0);
	*--s = 0;
	//print("%s\n", s0);
	putenv("okip", s0);
}

#ifdef XXX
void
main(int argc, char *argv[])
{
	char *e = nil;
	ARGBEGIN{
	case 'e':
		e = ARGF();
		break;
	default: break;
	}ARGEND
	
	while(*argv)
		updateOkip(*argv++);
	if(e)
		print("%d\n",okchk(e));
}
#endif
